100 REMark Text2Exp by Dilwyn Jones 1999
110 REMark converts text columns to Archive export file
120 REMark written originally for use with EasyBase
130 REMark this program is freeware
140 :
150 CLS : CLS #0
160 :
170 REMark arrays to define column start and end co-ordinates in lines
180 REMark of text, starting from 1 (i.e. left of line is 1)
190 DIM st%(59) : REMark field start across, from 1
200 DIM en%(59) : REMark field end point across, from 1
210 DIM fnm$(59,20) : REMark field names
220 DIM ff$(59,60) : REMark a record, up to 60 fields
230 :
240 INPUT#0,'How many fields/columns (1 to 60) > ';fields%
250 IF fields% < 1 THEN STOP
260 :
270 PRINT #0,'Take field names from text line 1 Y/N ? ';
280 IF INKEY$(-1) == 'y' THEN
290   PRINT #0,'y' : tfn% = 1
300 ELSE
310   PRINT #0,'n' : tfn% = 0 : REMark enter them instead
320 END IF
330 :
340 INPUT #0,'Filename of text file to load > ';tx$
350 INPUT #0,'Filename of _exp file to save > ';xp$
360 :
370 OPEN_IN #3,tx$
380 OPEN_NEW #4,xp$
390 :
400 REMark enter field start and end points
410 CLS : CLS #0
420 PRINT #0,'Enter field start and end columns above.'
430 FOR a = 0 TO fields%-1
440   INPUT (a+1);': ';st%(a);
450   INPUT '  ';en%(a)
460 END FOR a
470 :
480 REMark get field names
490 IF tfn% = 0 THEN
500   REMark need to enter field names
510   FOR a = 0 TO fields%-1
520     REPeat loop
530       INPUT #0,'Field ';(a+1);' name > ';t$
540       IF LEN(t$) < 17 THEN
550         fnm$(a) = t$ : PRINT a+1;':';t$ : EXIT loop
560       ELSE
570         BEEP 5000,50 : PRINT #0,'Too long - max 16 characters!'
580       END IF
590     END REPeat loop
600   END FOR a
610 ELSE
620   REMark take from file
630   INPUT #3,t$ : REMark get first line
640   PRINT 'Field names list'
650   FOR a = 0 TO fields%-1
660     fr_% = st%(a)
670     IF fr_% > LEN(t$) THEN
680       fnm$(a) = '' : REMark no data available, line too narrow!
690     ELSE
700       to_% = en%(a)
710       IF to_% > LEN(t$) THEN to_% = LEN(t$)
720       fnm$(a) = LRTRIM$(t$(fr_% TO to_%))
730     END IF
740     :
750     REMark print field name generated to screen
760     PRINT a+1;':';fnm$(a)
770     :
780   END FOR a
790   PAUSE 100
800 END IF
810 :
820 REMark we can now start to build up the export file
830 REMark first write out the field names list
840 l% = 0 : REMark lines done (i.e. records generated) count
850 FOR a = 0 TO fields%-1
860   PRINT #4,'"';fnm$(a);'"';
870   IF a < (fields%-1) THEN PRINT #4,',';
880 NEXT a
890   PRINT #4, : REMark LF at end of line
900 END FOR a
910 :
920 REMark now write out the lines of data
930 REPeat write_lines
940   IF EOF(#3) : EXIT write_lines
950   INPUT #3,t$
960   :
970   REMark extract fields and unspace
980   FOR a = 0 TO fields%-1
990     fr_% = st%(a)
1000     IF fr_% > LEN(t$) THEN
1010       ff$(a) = '' : REMark no data, text line too narrow!
1020     ELSE
1030       to_% = en%(a)
1040       IF to_% > LEN(t$) THEN to_% = LEN(t$)
1050       ff$(a) = LRTRIM$(t$(fr_% TO to_%))
1060     END IF
1070     :
1080     REMark unrem the following line for a display output of
1090     REMark the fields which the program extracts
1100     REMark PRINT a+1;':';ff$(a)
1110     :
1120   END FOR a
1130   :
1140   REMark write it out in export format
1150   FOR a = 0 TO fields% - 1
1160     PRINT #4,'"';ff$(a);'"';
1170     IF a < (fields%-1) THEN PRINT #4,',';
1180   NEXT a
1190     PRINT #4, : REMark LF at end of line
1200   END FOR a
1210   l% = l% + 1 : AT #0,2,0 : PRINT #0,l% : REMark records count
1220 END REPeat write_lines
1230 :
1240 CLOSE #3
1250 CLOSE #4
1260 :
1270 CLS #0
1280 PRINT #0,'Program finished.'
1290 :
1300 STOP
1310 :
1320 DEFine FuNction LRTRIM$(i$)
1330   LOCal t$,a
1340   REMark trim spaces from left and right of entry
1350   REMark left first
1360   tl% = 0 : REMark first non-space character
1370   tl% = 0 : REMark last non-space character
1380   FOR a = 1 TO LEN(i$)
1390     IF i$(a) <> ' ' THEN tl% = a : EXIT a
1400   END FOR a
1410   FOR a = LEN(i$) TO 1 STEP -1
1420     IF i$(a) <> ' ' THEN tr% = a : EXIT a
1430   END FOR a
1440   IF tl% > 0 AND tr% > 0 THEN
1450     t$ = i$(tl% TO tr%)
1460   ELSE
1470     t$ = '' : REMark must have been all spaces or null to start with
1480   END IF
1490   RETurn t$
1500 END DEFine LRTRIM$
